// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.annotatedlineeditor.handler;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Event;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.taxeditor.annotatedlineeditor.AnnotatedLineEditor;

/**
 * <p>NewObjectHandler class.</p>
 *
 * @author p.ciardelli
 * @created 14.08.2009
 * @version 1.0
 */
public class NewObjectHandler extends AbstractHandler {

	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
	 */
	/** {@inheritDoc} */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		
		IEditorPart editor = HandlerUtil.getActiveEditor(event);
		IEditorInput input = editor.getEditorInput();
		
		if (editor instanceof AnnotatedLineEditor) {
			
			Object key = ((Event)event.getTrigger()).data;
			if (key != null) {

				((AnnotatedLineEditor) editor).createAnnotatedLineNewObject(key, "Untitled");
				
			} else {
				((AnnotatedLineEditor) editor).createAnnotatedLineNewObject();
			}
		}
		return null;
	}
}
