// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.bulkeditor.input.entitycreator;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;

import eu.etaxonomy.cdm.model.agent.AgentBase;
import eu.etaxonomy.cdm.model.agent.Person;
import eu.etaxonomy.cdm.model.agent.Team;
import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
import eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator;

/**
 * <p>TeamOrPersonCreator class.</p>
 *
 * @author p.ciardelli
 * @created 18.09.2009
 * @version 1.0
 */
public class AgentCreator implements IEntityCreator<AgentBase> {
	private static final Logger logger = Logger
			.getLogger(AgentCreator.class);

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator#createEntity(java.lang.String)
	 */
	/** {@inheritDoc} */
	public AgentBase createEntity(String text) {
		// FIXME
		logger.error("FIXMEFIXMEFIXMEFIXMEFIXMEFIXMEFIXMEFIXMEFIXMEFIXMEFIXME");
		logger.error("We can only create Persons at the moment. See #1820");
		logger.error("FIXMEFIXMEFIXMEFIXMEFIXMEFIXMEFIXMEFIXMEFIXMEFIXMEFIXME");
		return createEntity(Person.class, text);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator#createEntity(java.lang.Class, java.lang.String)
	 */
	/** {@inheritDoc} */
	public AgentBase createEntity(Object key, String text) {
		TeamOrPersonBase teamOrPerson = null;
		if (Team.class.equals((key))) {
			teamOrPerson = Team.NewInstance();
		}
		if (Person.class.equals((key))) {
			teamOrPerson = Person.NewInstance();
		}		
		if (teamOrPerson != null) {
			teamOrPerson.setTitleCache(text, true);
		}
		return teamOrPerson;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.annotatedlineeditor.IEntityCreator#getClassLabelPairs()
	 */
	/**
	 * <p>getKeyLabelPairs</p>
	 *
	 * @return a {@link java.util.Map} object.
	 */
	public Map<Object, String> getKeyLabelPairs() {
		Map<Object, String> result = new HashMap<Object, String>();
		result.put(Team.class, "Author Team");
		result.put(Person.class, "Author");
		return result;
	}

	@Override
	public boolean savesEntity() {
		// TODO Auto-generated method stub
		return false;
	}
}
