// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.bulkeditor.input.sortprovider;

import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import eu.etaxonomy.taxeditor.bulkeditor.IBulkEditorSortProvider;

/**
 * @author n.hoffmann
 * @created Dec 14, 2010
 * @version 1.0
 */
public class AbstractSortProvider<T> implements IBulkEditorSortProvider<T> {

	Map<String, Comparator<T>> comparators = new HashMap<String, Comparator<T>>();
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.IBulkEditorSortProvider#getComparators()
	 */
	@Override
	public Map<String, Comparator<T>> getComparators() {
		return comparators;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.IBulkEditorSortProvider#getComparatorNames()
	 */
	@Override
	public Set<String> getComparatorNames() {
		return comparators.keySet();
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.IBulkEditorSortProvider#getComparatorByName(java.lang.String)
	 */
	@Override
	public Comparator<T> getComparatorByName(String name) {
		return comparators.get(name);
	}

}
